<template>
  <main>
    <mt-page-title :link-to="{ name: 'profil-dashboard-postesro', params: { profil: 'admin' } }" link-text="retour">
      <h1 class="has-text-weight-bold is-size-3">Editer le Poste au RO</h1>
    </mt-page-title>
    <form @submit.prevent="submit">
      <mt-champs-form-poste-ro :poste-ro="posteRo" />
      <div class="columns is-centered">
        <b-button type="is-primary" class="mt-button is-size-8" native-type="submit">
          Enregistrer les modifications
        </b-button>
      </div>
    </form>
  </main>
</template>

<script>
import MtPageTitle from '~/components/base/page-title/index';
import MtChampsFormPosteRo from '~/components/dashboard/postero/champs-form-poste-ro';
import newPosteRo from '~/components/mixins/posteRoMixin';

export default {
  layout: 'container-small',
  components: {
    MtPageTitle,
    MtChampsFormPosteRo,
  },
  async asyncData(context) {
    const posteRo = Object.assign(newPosteRo(), await context.$api.postesRo.get(context.params.id));
    return {
      posteRo,
    };
  },
  methods: {
    async submit() {
      try {
        await this.$api.postesRo.put(this.posteRo.id, this.posteRo);
        this.$router.push({ name: 'profil-dashboard-postesro', params: { profil: 'admin' } });
      } catch ({
        response: {
          status,
          data: { message },
        },
      }) {
        this.$buefy.notification.open({
          message,
          type: 'is-danger',
          duration: 5000,
        });
      }
    },
  },
};
</script>

<style scoped lang="scss"></style>
